function output=forward_drop_A(thresholds,q_F_1_A,q_F_0_A,q_E_1_A,q_E_0_A,q_P_1_A,q_P_0_A,T_A,cred_F,cred_P,cred_E,grid_p,step,N)

% clear all
% close all
% clc
% 
% q_F_1_A=0.00001;
% q_F_0_A=0.23;
% q_E_1_A=0.13;
% q_E_0_A=0.075;
% q_P_1_A=1-q_F_1_A-q_E_1_A;
% q_P_0_A=1-q_F_0_A-q_E_0_A;
% 
% T_A=8;
% 
% step=0.001;
% grid_p=[0:step:1];
% grid_p=grid_p';
% N=length(grid_p);
% 
% %credits
% cred_F=0;
% cred_P=1;
% cred_E=1;
% 
% thresholds=[0.2730    0.5260
%     0.2280    0.4920
%     0.1500    0.5350
%     0.0520    0.5870
%          0    0.7000
%          0    0.8260
%          0    0.6460
%          0    0.7000
%          0    0.7390];
     
Q=zeros(N,T_A+1);

if thresholds(T_A+1,1)>0
    if thresholds(T_A+1,1)>=1
        pos=N;
    else
        aux=find(grid_p>thresholds(T_A+1,1));
        pos=aux(1);
        clear aux
    end
    Q(1:pos-1,T_A+1)=1;
    clear pos
end

for i=1:T_A
    if thresholds(T_A+1-i,1)>=1
        pos=N;
    else
        aux=find(grid_p>thresholds(T_A+1-i,1));
        pos=aux(1);
        clear aux
    end
    Q(1:pos-1,T_A+1-i)=1;
    if thresholds(T_A+1-i,2)>=1
        pos_2=N;
    else
        aux=find(grid_p>thresholds(T_A+1-i,2));
        pos_2=aux(1);
        clear aux
    end
    for j=1:pos_2-(pos-1)
        p=grid_p(pos-1+j);
        if p==1    
            p_E=1;
            p_P=1;
            p_F=1;
        elseif p==0
            p_E=0;
            p_P=0;
            p_F=0;
        else
            p_E=update(p,q_E_0_A,q_E_1_A);
            p_P=update(p,q_P_0_A,q_P_1_A);
            p_F=update(p,q_F_0_A,q_F_1_A);
        end
        if p_E==1
            ubic_E=N;
        elseif p_E==0
            ubic_E=1;
        else
            aux=find(grid_p>p_E);
            ubic_E=aux(1)-1;
            clear aux
        end
        if p_P==1
            ubic_P=N;
        elseif p_P==0
            ubic_P=1;
        else
            aux=find(grid_p>p_P);
            ubic_P=aux(1)-1;
            clear aux
        end
        if p_F==1
            ubic_F=N;
        elseif p_F==0
            ubic_F=1;
        else
            aux=find(grid_p>p_F);
            ubic_F=aux(1)-1;
            clear aux
            if p_F>0 & ubic_F==1
                ubic_F=2;
            end
        end
        Q_1=q_E_1_A*Q(ubic_E,T_A+1-i+cred_E)+q_P_1_A*Q(ubic_P,T_A+1-i+cred_P)+q_F_1_A*Q(ubic_F,T_A+1-i+cred_F);
        Q_0=q_E_0_A*Q(ubic_E,T_A+1-i+cred_E)+q_P_0_A*Q(ubic_P,T_A+1-i+cred_P)+q_F_0_A*Q(ubic_F,T_A+1-i+cred_F);
        Q(pos-1+j,T_A+1-i)=p*Q_1+(1-p)*Q_0;
        clear Q_1 Q_0
    end
    clear pos pos_2
end
if thresholds(1,1)<=0
    ubic_L=1;
elseif thresholds(1,1)>=1
    ubic_L=N;
    ubic_H=N;
else
    aux=find(grid_p>thresholds(1,1));
    ubic_L=aux(1);
    clear aux
    if thresholds(1,2)>=1
        ubic_H=N;
    else
        aux=find(grid_p>thresholds(1,2));
        ubic_H=aux(1)-1;
        clear aux
    end
end
Y=Q(ubic_L:ubic_H,1);
x=grid_p(ubic_L:ubic_H);
X=[ones(length(x),1) x x.^2 x.^3];
coef=regress(Y,X);
est=X*coef;
% plot(x,Q(ubic_L:ubic_H,1))
% hold on
% plot(x,est,'r')
output=coef;%Q(ubic_L:ubic_H,1);
