function output=forward_drop_C(thresholds,q_F_1_C,q_F_0_C,q_E_1_C,q_E_0_C,q_P_1_C,q_P_0_C,T_C,cred_F,cred_P,cred_E,grid_p,step,N)

% clear all
% close all
% clc
% 
% q_F_1_C=0.01;
% q_F_0_C=0.22;
% q_E_1_C=0.18;
% q_E_0_C=0.001;
% q_P_1_C=1-q_F_1_C-q_E_1_C;
% q_P_0_C=1-q_F_0_C-q_E_0_C;
% 
% T_C=16;
% 
% step=0.001;
% grid_p=[0:step:1];
% grid_p=grid_p';
% N=length(grid_p);
% 
% %credits
% cred_F=0;
% cred_P=1;
% cred_E=1;

% thresholds=[0.2770    0.5410
%     0.2770    0.3200
%     0.2750         0
%     0.2600         0
%     0.2420         0
%     0.2230         0
%     0.2000         0
%     0.1750         0
%     0.1420         0
%     0.1040         0
%     0.0530         0
%          0         0
%          0         0
%          0         0
%          0         0
%          0         0
%          0         0];
     
Q=zeros(N,T_C+1);

if thresholds(T_C+1,1)>0
    if thresholds(T_C+1,1)>=1
        pos=N;
    else
        aux=find(grid_p>thresholds(T_C+1,1));
        pos=aux(1);
        clear aux
    end
    Q(1:pos-1,T_C+1)=1;
    clear pos
else
    Q(1,T_C+1)=0;
end
for i=1:T_C
    if thresholds(T_C+1-i,1)>=1
        pos=N;
    else
        aux=find(grid_p>thresholds(T_C+1-i,1));
        pos=aux(1);
        clear aux
    end
    Q(1:pos-1,T_C+1-i)=1;
    if thresholds(T_C+1-i,2)>=1
        pos_2=N;
    else
        aux=find(grid_p>thresholds(T_C+1-i,2));
        pos_2=aux(1);
        clear aux
    end
    if pos_2>=pos
        aux_pos=pos_2;
    else
        aux_pos=pos;
    end
    for j=1:N-(aux_pos-1)
        p=grid_p(N+1-j);
        if p==1    
            p_E=1;
            p_P=1;
            p_F=1;
        elseif p==0
            p_E=0;
            p_P=0;
            p_F=0;
        else
            p_E=update(p,q_E_0_C,q_E_1_C);
            p_P=update(p,q_P_0_C,q_P_1_C);
            p_F=update(p,q_F_0_C,q_F_1_C);
        end
        if p_E==1
            ubic_E=N;
        elseif p_E==0
            ubic_E=1;
        else
            aux=find(grid_p>p_E);
            ubic_E=aux(1)-1;
            clear aux
        end
        if p_P==1
            ubic_P=N;
        elseif p_P==0
            ubic_P=1;
        else
            aux=find(grid_p>p_P);
            ubic_P=aux(1)-1;
            clear aux
        end
        if p_F==1
            ubic_F=N;
        elseif p_F==0
            ubic_F=1;
        else
            aux=find(grid_p>p_F);
            ubic_F=aux(1)-1;
            clear aux
            if p_F>0 & ubic_F==1
                ubic_F=2;
            end
        end
        Q_1=q_E_1_C*Q(ubic_E,T_C+1-i+cred_E)+q_P_1_C*Q(ubic_P,T_C+1-i+cred_P)+q_F_1_C*Q(ubic_F,T_C+1-i+cred_F);
        Q_0=q_E_0_C*Q(ubic_E,T_C+1-i+cred_E)+q_P_0_C*Q(ubic_P,T_C+1-i+cred_P)+q_F_0_C*Q(ubic_F,T_C+1-i+cred_F);
        Q(N+1-j,T_C+1-i)=p*Q_1+(1-p)*Q_0;
        clear Q_1 Q_0
    end
    clear pos pos_2 aux_pos
end
if thresholds(1,2)<=0
    ubic_L=1;
elseif thresholds(1,2)>=1
    ubic_L=N;
else
    aux_ubic=find(grid_p>thresholds(1,2));
    ubic_L=aux_ubic(1);
    clear aux_ubic
end
ubic_H=N;
Y=Q(ubic_L:ubic_H,1);
x=grid_p(ubic_L:ubic_H);
X=[ones(length(x),1) x x.^2 x.^3];
coef=regress(Y,X);
est=X*coef;
% plot(x,Q(ubic_L:ubic_H,1))
% hold on
% plot(x,est,'r')
output=coef;%Q(ubic_L:ubic_H,1);
